/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 1.11B */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "trekclock.h"
#include "abimport.h"
#include "proto.h"

extern PhImage_t *fnums[11];
extern PhImage_t *knums[11];
extern PtArg_t arg[5];
extern int hours;
extern int clock_mode;

int
change_hours( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )
	
	{
	/////////////////////////////////////////////////////////////////////////
	//Determine which of the arrows (up or down) has been pressed and
	//increment or decrement a value depending on that. The value is a global
	//because the set callback will make use of it to initialise a timer.
	//Once we have th evalue we need to update the on-screen display with
	//the appropriate bitmap to give th euser some feedback.
	///////////////////////////////////////////////////////////////////////
	int h1,h2;

	if(widget==ABW_u1)
		{
		hours++;
		//put in 24 hour clock
		h1=(hours-(hours%10))/10;	
		h2=hours%10;
		}//if
	else
		{
		hours--;
		//put in 24 hour clock
		h1=(hours-(hours%10))/10;	
		h2=hours%10;
		}//else

	if(clock_mode==STANDARD)
		{
		PtSetArg(&arg[0],Pt_ARG_LABEL_DATA,fnums[h1],sizeof(*fnums[h1]));
		PtSetArg(&arg[1],Pt_ARG_LABEL_DATA,fnums[h2],sizeof(*fnums[h2]));
		}//if
	else
		{
		PtSetArg(&arg[0],Pt_ARG_LABEL_DATA,knums[h1],sizeof(*knums[h1]));
		PtSetArg(&arg[1],Pt_ARG_LABEL_DATA,knums[h2],sizeof(*knums[h2]));
		}

	
	PtSetResources(ABW_ah10,1,arg);
	PtSetResources(ABW_ah,1,&arg[1]);

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	return( Pt_CONTINUE );

	}

