/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 1.11B */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "trekclock.h"
#include "abimport.h"
#include "proto.h"

extern PhImage_t *knums[11];
extern PtArg_t arg[5];
extern int mins;


int
change_kmin( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{
	///////////////////////////////////////////////////////////////////////
	//Determine which widget was pressed - (up or down) and increment or
	//decrement the global mins variable accordingly. Here is where we do
	//the range checking and once we have two integers - one for tens of
	//minutes and one for minutes we can use those as indexes into the 
	//fnums[] array to update the appropriate bitmap with the correct
	//picture.
	///////////////////////////////////////////////////////////////////////
	int m1,m2;

	if(widget==ABW_kmu)
		{
		mins++;
		if(mins==60)
			mins=0;
		}
	else
		{
		mins--;
		if(mins==-1)
			mins=59;
		}		
	m1=(mins-(mins%10))/10;
	m2=mins%10;

	PtSetArg(&arg[0],Pt_ARG_LABEL_DATA,knums[m1],sizeof(*knums[m1]));
	PtSetResources(ABW_km10,1,arg);
	PtSetArg(&arg[0],Pt_ARG_LABEL_DATA,knums[m2],sizeof(*knums[m2]));
	PtSetResources(ABW_km1,1,arg);
	PtFlush();

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	return( Pt_CONTINUE );

	}

