/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 1.11B */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "trekclock.h"
#include "abimport.h"
#include "proto.h"

extern int clock_mode;
extern void load_values(void);
extern PtArg_t arg[5];
extern PhImage_t *ab[2];
extern PhImage_t *cl[2];
extern PhImage_t *alarm_array[2][2];
extern PhImage_t *alarm_but[2];
extern int picture_num;

int
change_lang( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{
	/////////////////////////////////////////////////////////////////////
	//When the user changes mode we want to update all the bitmaps to
	//reflect this.
	//////////////////////////////////////////////////////////////////////
	if(clock_mode==STANDARD)
		clock_mode=KLINGON;
	else
		clock_mode=STANDARD;

	load_values();
	
	PtSetArg(&arg[0],Pt_ARG_LABEL_DATA,cl[clock_mode],sizeof(*cl[clock_mode]));
	PtSetResources(ABW_changelang,1,arg);
	PtSetArg(&arg[0],Pt_ARG_LABEL_DATA,ab[clock_mode],sizeof(*ab[clock_mode]));
	PtSetResources(ABW_about,1,arg);
	PtSetArg(&arg[0],Pt_ARG_LABEL_DATA,alarm_array[clock_mode][picture_num],
			sizeof(*alarm_array[clock_mode][picture_num]));
	PtSetResources(ABW_logo,1,arg);
	PtSetArg(&arg[0],Pt_ARG_LABEL_DATA,alarm_but[clock_mode],
		sizeof(*alarm_but[clock_mode]));
	PtSetResources(ABW_alarm,1,arg);
	PtFlush();

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	return( Pt_CONTINUE );

	}

