/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 1.11B */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "trekclock.h"
#include "abimport.h"
#include "proto.h"

int mins=0,hours=0;
extern PtArg_t arg[5];
extern int clock_mode;
extern PhImage_t *fnums[11];
extern PhImage_t *knums[11];
extern int ALARM[2];
extern char almsg[81];

void block_base(int block)
	{
	////////////////////////////////////////////////////////////////////
	//A convenient function that can be called to block ALL input to the
	//base window or to unblock all input to the base window.
	//This is achieved by setting the blocked flag (Pt_BLOCKED) and by
	//changing the cursor to the "no-entry" sign.
	/////////////////////////////////////////////////////////////////////
	if(block)
		{
		PtSetArg(&arg[0],Pt_ARG_CURSOR_TYPE,Ph_CURSOR_NOINPUT,0);
		PtSetArg(&arg[1],Pt_ARG_FLAGS,Pt_BLOCKED,Pt_BLOCKED);
		PtSetResources(ABW_base,2,arg);
		}
	else
		{
		PtSetArg(&arg[0],Pt_ARG_CURSOR_TYPE,Ph_CURSOR_POINTER,0);
		PtSetArg(&arg[1],Pt_ARG_FLAGS,0,Pt_BLOCKED);
		PtSetResources(ABW_base,2,arg);
		}
	}

int
setup_alarms( PtWidget_t *link_instance, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{
	int num;
	///////////////////////////////////////////////////////////////////
	//We only needed to initialise those global variable for the callbacks
	//to manipulate and block the base window making the dialog modal.
	//Decide which mode we're running in and then launch the appropriate
	//alarm dialog.
	///////////////////////////////////////////////////////////////////

	block_base(1);

	//////////////////////////////////////////////////////////////////
	//We need to mask out the Pt_FREE_MEMORY flag otherwise a label
	//widget on a Dialog will free the memory that it points to when it is 
	//destroyed. Now I have many other widgets pointing to those images
	//and I don't want the underlying memory freed - cos that would be BAD.
	/////////////////////////////////////////////////////////////////

	if(clock_mode==STANDARD)
		{
		ApCreateModule(ABM_alarm_set,link_instance,cbinfo);
		PtSetArg(&arg[0],Pt_ARG_FLAGS,0,Pt_FREE_MEMORY);
		PtSetResources(ABW_fh10,1,arg);
		PtSetResources(ABW_fh1,1,arg);
		PtSetResources(ABW_fm10,1,arg);
		PtSetResources(ABW_fm1,1,arg);
		if(ALARM[0]!=100)
			{
			num=(ALARM[0]-(ALARM[0]%10))/10;
			PtSetArg(&arg[0],Pt_ARG_LABEL_DATA,fnums[num],
				sizeof(*fnums[num]));
			PtSetResources(ABW_fh10,1,arg);
			num=ALARM[0]%10;
			PtSetArg(&arg[0],Pt_ARG_LABEL_DATA,fnums[num],
				sizeof(*fnums[num]));
			PtSetResources(ABW_fh1,1,arg);
			num=(ALARM[1]-(ALARM[1]%10))/10;
			PtSetArg(&arg[0],Pt_ARG_LABEL_DATA,fnums[num],
				sizeof(*fnums[num]));
			PtSetResources(ABW_fm10,1,arg);
			num=ALARM[1]%10;
			PtSetArg(&arg[0],Pt_ARG_LABEL_DATA,fnums[num],
				sizeof(*fnums[num]));
			PtSetResources(ABW_fm1,1,arg);
			PtSetArg(&arg[0],Pt_ARG_TEXT_STRING,almsg,0);
			PtSetResources(ABW_falarmtext,1,arg);
			}
		else
			hours=mins=0;
		}//if
	else
		{
		ApCreateModule(ABM_alarm_setk,link_instance,cbinfo);
		PtSetArg(&arg[0],Pt_ARG_FLAGS,0,Pt_FREE_MEMORY);
		PtSetResources(ABW_kh10,1,arg);
		PtSetResources(ABW_kh1,1,arg);
		PtSetResources(ABW_km10,1,arg);
		PtSetResources(ABW_km1,1,arg);
		if(ALARM[0]!=100)
			{
			num=(ALARM[0]-(ALARM[0]%10))/10;
			PtSetArg(&arg[0],Pt_ARG_LABEL_DATA,knums[num],
				sizeof(*knums[num]));
			PtSetResources(ABW_kh10,1,arg);
			num=ALARM[0]%10;
			PtSetArg(&arg[0],Pt_ARG_LABEL_DATA,knums[num],
				sizeof(*knums[num]));
			PtSetResources(ABW_kh1,1,arg);
			num=(ALARM[1]-(ALARM[1]%10))/10;
			PtSetArg(&arg[0],Pt_ARG_LABEL_DATA,knums[num],
				sizeof(*knums[num]));
			PtSetResources(ABW_km10,1,arg);
			num=ALARM[1]%10;
			PtSetArg(&arg[0],Pt_ARG_LABEL_DATA,knums[num],
				sizeof(*knums[num]));
			PtSetResources(ABW_km1,1,arg);
			PtSetArg(&arg[0],Pt_ARG_TEXT_STRING,almsg,0);
			PtSetResources(ABW_kalarmtext,1,arg);
			}
		else
			hours=mins=0;
		}//else

	PtFlush();

	/* eliminate 'unreferenced' warnings */
	link_instance = link_instance, apinfo = apinfo, cbinfo = cbinfo;

	return( Pt_CONTINUE );

	}

